<?php

class PushNotification {

    private static $API_ACCESS_KEY = "AAAAocCl4Mg:APA91bFYF93LgK7wWEIweyR5fIQHuRtPGaAyLuFs5zr7Yq4w19ifxQc43lC9EnMgVfxO0WqfVXTpxeSt9HjFh5wroA8u1oozZa6EyakjXQzyVZZmXVyoH9nXBoKyDNrscLUvXGLQYT4_"; // YOUR FIREBASE API_KEY

    public static function sendNotification($target = array(), $fields = array(), $data = array()) {

        $postdata = array();
        /*
         * setting registrations ids or to only one at a time
         * because we can send notfication to registrations ids or to at once 
         */
        if (isset($target['registration_ids']) && is_array($target['registration_ids']) && !empty($target['registration_ids'])) {
            $postdata['registration_ids'] = $target['registration_ids'];
        } else if (isset($target['topic']) && trim($target['topic']) <> "") {
            $postdata['to'] = "/topics/" . $target['topic'];
        }
        /* setting Notification title & message body */
        $postdata['notification'] = array('title' => $fields['title'], 'body' => $fields['body']);
        /* setting custom data if not empty */
        if (!empty($data)) {
            $postdata['data'] = $data;
        }

        $headers = array(
            'Authorization: key=' . self::$API_ACCESS_KEY,
            'Content-Type: application/json'
        );

        #Send Request To FireBase Server
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, "https://fcm.googleapis.com/fcm/send"); //API URL of FCM
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($postdata));
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }

    public static function registerForNotification($token, $topic = "android") {
        //$url = "https://iid.googleapis.com/iid/v1:batchRemove";
        $fields['registration_tokens'] = is_array($token) ? $token : array($token);
        $fields['to'] = '/topics/' . $topic;

        $headers = array(
            'Authorization: key=' . self::$API_ACCESS_KEY,
            'Content-Type:application/json'
        );

        #Send Request To FireBase Server
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, 'https://iid.googleapis.com/iid/v1:batchAdd');
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
        $result = curl_exec($ch);
        curl_close($ch);
        return $result;
    }

}
